function ValidateClient(a) {
    this.config = {};
    this.$fb = a;
    this.maxnumerrors = -1
}
ValidateClient.prototype.clone = function(c) {
    if (c == null || typeof(c) != "object") {
        return c
    }
    var a = {};
    for (var b in c) {
        a[b] = this.clone(c[b])
    }
    return a
};
ValidateClient.prototype.init_editor = function() {
    this.$fb("#fb-submit-button").click(function() {
        return false
    })
};
ValidateClient.prototype.init_client = function(a) {
    var b = this;
    this.$fb("#docContainer input:submit, #docContainer button:submit").click(function(c) {
        b.$fb("#docContainer .placeholder").val("");
        if (b.$fb("#docContainer").attr("data-form") == "automated" || b.$fb("#docContainer").attr("data-form") == "publish") {
            if (!b.$fb("#docContainer").valid()) {
                var d = b.$fb("#docContainer").attr("action");
                var e = b.$fb("#docContainer").validate().numberOfInvalids();
                d = d.replace(/(?:\.php)|\/$/i, "/fbapp/api/formchangestats.php?error=" + e);
                b.$fb.get(d)
            }
        }
        if (b.$fb(this).attr("data-disabled")) {
            c.preventDefault();
            c.stopPropagation();
            return false
        }
        if (b.$fb("#docContainer").valid()) {
            b.$fb(this).attr("data-disabled", "disabled")
        }
        return true
    });
    // if (a) {
    //         this.$fb.validator.setDefaults({
    //             submitHandler: function(c) {
    //                 if (b.$fb(c).valid()) {
    //                     alert("Submitted!");
    //                 }
    //             }
    //         })
    //     }
    this.$fb("#docContainer").validate({
        errorPlacement: function(d, e) {
            if (b.maxnumerrors != -1) {
                var c = 0;
                b.$fb.each(b.$fb("#docContainer label.error"),
                function(g, f) {
                    if (b.$fb(f).css("display") != "none") {
                        c++
                    }
                });
                if (c >= b.maxnumerrors) {
                    return
                }
            }
            offset = e.offset();
            if (b.$fb(e).attr("type") == "checkbox" || b.$fb(e).attr("type") == "radio") {
                b.$fb(e).parent().parent().append(b.$fb(d))
            } else {
                if (b.$fb(e).attr("id") == "recaptcha_response_field") {
                    b.$fb(d).insertAfter(b.$fb("#recaptcha_area"))
                } else {
                    b.$fb(d).insertAfter(b.$fb(e))
                }
            }
            d.addClass("message")
        }
    });
    this.set_config(JSON.parse(data_validation));
    this.add_rules()
};
ValidateClient.prototype.set_config = function(a) {
    this.config = this.clone(a)
};
ValidateClient.prototype.set_config_json = function(a) {
    if (typeof a == "undefined" || a === null || typeof a != "string") {
        return false
    }
    this.config = JSON.parse(a);
    return true
};
ValidateClient.prototype.add_rule_type = function(e, k) {
    if (arguments.length != 2) {
        return false
    }
    if (typeof this.config[e] == "undefined" || this.config[e] === null) {
        return false
    }
    if (typeof this.config[e][k] == "undefined" || this.config[e][k] === null || this.config[e][k] == "") {
        return false
    }
    if (e != "reCaptcha" && e != "_special" && !this.$fb("#" + e).length) {
        return false
    }
    var n = this;
    if (k == "date_config") {
        if ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i))) {
            var g = this.$fb("#" + e).clone();
            g.attr("type", "text");
            this.$fb("#" + e).replaceWith(g)
        }
        this.$fb("#" + e).attr("id", "").removeClass("hasDatepicker").removeData("datepicker").unbind().attr("id", e).datepicker({
            onClose: function() {
                n.$fb("#docContainer").validate().element(this)
            },
            showAnim: ""
        });
        for (var d in this.config[e][k]) {
            if (this.config[e][k].hasOwnProperty(d)) {
                var h = {};
                if (d == "minDate" || d == "maxDate") {
                    if (this.config[e][k][d] != "") {
                        h[d] = new Date(this.config[e][k][d])
                    }
                } else {
                    h[d] = this.config[e][k][d]
                }
                this.$fb("#" + e).datepicker("option", d, h[d])
            }
        }
    } else {
        if (k == "hover") {
            var f = document.getElementById("form_init_script").getAttribute("data-name");
            var j = 4;
            if (navigator.appName == "Microsoft Internet Explorer") {
                j = 5
            }
            for (var m in this.config[e][k]) {
                var l = this.$fb("#" + e).css(m);
                var i = n.config[e][k][m];
                if ((this.$fb("#docContainer").attr("data-form") == "automated" && this.$fb("#docContainer").attr("action") != "./") || (this.$fb("#docContainer").attr("data-form") == "manual_iframe" && this.$fb("#docContainer").attr("action") != "../" + f + ".php")) {
                    i = i != "" ? i.substr(0, 4) + f + i.substr(4, i.length) : i
                }
                var n = this;
                this.$fb("#" + e).hover(function() {
                    if (i != "none" && i != "") {
                        n.$fb(this).css("background-image", i)
                    } else {
                        if (i == "none") {
                            n.$fb(this).css("background-image", l)
                        } else {
                            n.$fb(this).css("background-image", "")
                        }
                    }
                },
                function() {
                    if (i != "") {
                        n.$fb(this).css("background-image", l)
                    }
                })
            }
        } else {
            if (k == "maxnumerrors") {
                if (this.config[e][k] != undefined && this.config[e][k] != "") {
                    this.maxnumerrors = this.config[e][k]
                }
            } else {
                if (k == "captcha") {
                    if (this.config[e][k] && this.$fb("#recaptcha_response_field").length) {
                        this.$fb("#recaptcha_response_field").rules("add", {
                            required: true
                        })
                    }
                } else {
                    var a = {};
                    a[k] = this.config[e][k];
                    if (this.$fb("#" + e).is("input[type='checkbox']") && k == "minlength") {
                        var c = {};
                        c[k] = "Please select at least {0} options.";
                        a.messages = c
                    }
                    if (typeof(this.config[e].messages) == "string") {
                        var b = {};
                        b[k] = this.config[e].messages;
                        a.messages = b
                    }
                    this.$fb("#" + e).rules("add", a)
                }
            }
        }
    }
    return true
};
ValidateClient.prototype.add_rule_id = function(b) {
    if (arguments.length != 1) {
        return false
    }
    if (typeof this.config[b] == "undefined" || this.config[b] === null) {
        return false
    }
    for (var a in this.config[b]) {
        if (this.config[b].hasOwnProperty(a)) {
            this.add_rule_type(b, a)
        }
    }
    return true
};
ValidateClient.prototype.add_rules = function() {
    for (var a in this.config) {
        if (this.config.hasOwnProperty(a)) {
            this.add_rule_id(a)
        }
    }
    return true
};