function xmlhttpPost(strURL,obj) {
    var xmlHttpReq = false;
    var self = this;
    // Mozilla/Safari
    if (window.XMLHttpRequest) {
        self.xmlHttpReq = new XMLHttpRequest();
    }
    // IE
    else if (window.ActiveXObject) {
        self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");
    }
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.onreadystatechange = function() {
        if (self.xmlHttpReq.readyState == 4) {
            updateBreedField(self.xmlHttpReq.responseText,obj);
        }
    }
    self.xmlHttpReq.send(strURL);
}

function getBreeds(species,obj) {
	xmlhttpPost("getBreeds.shtml?species="+species,obj);
}

function updateBreedField(data,obj) { //data is a string in the form breedCode^BreedName|[...]
	var breedRecords = data.split("|");
	var breedRecord;
	var ttr = "";
	//var breedSelect = document.getElementById('item15_select_1');
	var breedSelect = document.getElementById(obj);
	breedSelect.disabled=false;
	breedSelect.options.length=0;
	for (var i=0;i<breedRecords.length;i++) {
		breedRecord = breedRecords[i].split('^');
		breedSelect.options[i]=new Option( breedRecord[1], breedRecord[0], false, false)
	}
	if (i==1 && breedRecord[0]=='Please choose a species first.') {
		breedSelect.disabled=true;	
	}	
}

var numPetFields=1;
function showMorePetFields() {
	numPetFields++;
	maxPets = 3;
	if (numPetFields>maxPets) {
		alert("Sorry - you can only add 2 pets at a time. Please see receptionist.");
	} else {
		obj = document.getElementById("pet"+numPetFields);
		obj.style.display='block';
		if (numPetFields == maxPets) {
			addAnother = document.getElementById("addAnotherPet");
			addAnother.style.visibility='hidden';
		}
	}
}